﻿class DragMe {
	//ドラッグ対象のMC
	var photo_mc:MovieClip;
	//ドラッグできる領域
	var zone_mc:MovieClip;
	var left:Number;
	var top:Number;
	var right:Number;
	var bottom:Number;
	//
	//コンストラクタ
	function DragMe(targetMC:MovieClip, theZone:MovieClip) {
		photo_mc = targetMC;
		zone_mc = theZone;
		//領域の範囲を調べる
		var zoneBounds:Object = zone_mc.getBounds(_root);
		var zoneRect:Object = zone_mc.getRect(_root);
		//線幅（1/2幅）を計算する
		var lineTickness:Number = zoneBounds.xMin-zoneRect.xMin;
		//線幅を除いたドラッグ領域
		var boundLeft:Number = zoneRect.xMin-lineTickness;
		var boundTop:Number = zoneRect.yMin-lineTickness;
		var boundRight:Number = zoneRect.xMax+lineTickness;
		var boundBottom:Number = zoneRect.yMax+lineTickness;
		//写真の大きさと縮小率を考慮したドラッグ制限領域
		var photoBounds:Object = photo_mc.getBounds(photo_mc);
		left = boundLeft-photoBounds.xMin*photo_mc._xscale/100;
		top = boundTop-photoBounds.yMin*photo_mc._yscale/100;
		right = boundRight-photoBounds.xMax*photo_mc._xscale/100;
		bottom = boundBottom-photoBounds.yMax*photo_mc._yscale/100;
		//スコープ
		var scope = this;
		//
		//ドラッグするMCのイベントハンドラの設定
		//
		photo_mc.onPress = function() {
			//ドラッグ開始
			this.startDrag(false, scope.left, scope.top, scope.right, scope.bottom);
			// 半透明にする
			this._alpha = 50;
			//最前面にする
			this.swapDepths(_root.getNextHighestDepth());
			//画面のリフレッシュ
			this.onMouseMove = function() {
				updateAfterEvent();
			};
		};
		//
		photo_mc.onRelease = photo_mc.onReleaseOutside=function () {
			//ドラッグ終了
			this.stopDrag();
			//半透明を止める
			this._alpha = 100;
			//マウスが動く度のリフレッシュを止める
			delete this.onMouseMove;
		};
	}
}
